#!/bin/sh
top_builddir=${top_builddir:-..}
cr_run=${cr_run:-${top_builddir}/util/cr_run/cr_run}
cr_checkpoint=${cr_checkpoint:-${top_builddir}/util/cr_checkpoint/cr_checkpoint}
for dir in `dirname $0` . ${top_builddir}/tests; do
  test -x ${dir}/pause && break
done
#
${cr_run} --omit ${dir}/pause >/dev/null 2>/dev/null &
pid=$!
ESRCH=3
${cr_checkpoint} --term $pid 2>/dev/null
result=$?
if test $result = $ESRCH; then
  : # OK
elif test $result = 0; then
  echo "Checkpoint suceeded unexpectedly" >&2
  exit 1
else
  echo "Checkpoint unexpectedly failed with exit code $result" >&2
  exit 1
fi
exec 2>/dev/null # Drop job control message(s)
kill $pid
result=$?
wait $pid
exec 2>&1
if test $result = 0; then
  : # OK
else
  echo "Target process disappeared unexpectedly" >&2
  exit 1
fi
exit 0
